gtkmm 4.15.0

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Symbols | List of all members
Gdk::CicpParams Class Reference

Gdk::CicpParams contains the parameters that define a colorstate according to the ITU-T H.273 specification. More...

`#include <gdkmm/cicpparams.h>`

Inheritance diagram for Gdk::CicpParams:
[legend]

## Public Types
enum class | Range { Range::NARROW , Range::FULL }
| The values of this enumeration describe whether image data uses the full range of 8-bit values. More...
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from sigc::notifiable
typedef internal::func_destroy_notify | func_destroy_notify

## Public Member Functions
| CicpParams (CicpParams && src) noexcept
CicpParams & | operator= (CicpParams && src) noexcept
| ~CicpParams () noexcept override
GdkCicpParams * | gobj ()
| Provides access to the underlying C GObject.
const GdkCicpParams * | gobj () const
| Provides access to the underlying C GObject.
GdkCicpParams * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
guint | get_color_primaries () const
| Returns the value of the color-primaries property of self.
void | set_color_primaries (guint color_primaries)
| Sets the color-primaries property of self.
guint | get_transfer_function () const
| Gets the transfer-function property of self.
void | set_transfer_function (guint transfer_function)
| Sets the transfer-function property of self.
guint | get_matrix_coefficients () const
| Gets the matrix-coefficients property of self.
void | set_matrix_coefficients (guint matrix_coefficients)
| Sets the matrix-coefficients property of self.
Range | get_range () const
| Gets the range property of self.
void | set_range (Range range)
| Sets the range property of self.
Glib::RefPtr< ColorState > | build_color_state () const
| Creates a new `Gdk::ColorState` object for the cicp parameters in self.
Glib::PropertyProxy< guint > | property_color_primaries ()
| The color primaries to use.
Glib::PropertyProxy_ReadOnly< guint > | property_color_primaries () const
| The color primaries to use.
Glib::PropertyProxy< guint > | property_transfer_function ()
| The transfer function to use.
Glib::PropertyProxy_ReadOnly< guint > | property_transfer_function () const
| The transfer function to use.
Glib::PropertyProxy< guint > | property_matrix_coefficients ()
| The matrix coefficients (for YUV to RGB conversion).
Glib::PropertyProxy_ReadOnly< guint > | property_matrix_coefficients () const
| The matrix coefficients (for YUV to RGB conversion).
Glib::PropertyProxy< Range > | property_range ()
| Whether the data is using the full range of values.
Glib::PropertyProxy_ReadOnly< Range > | property_range () const
| Whether the data is using the full range of values.
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data_with_c_callback (const Quark &key, void *data, GDestroyNotify notify)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (notifiable *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (notifiable *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static Glib::RefPtr< CicpParams > | create ()
| Creates a new `Gdk::CicpParams` object.

## Protected Member Functions
| CicpParams ()
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Related Symbols
(Note that these are not member symbols.)
Glib::RefPtr< Gdk::CicpParams > | wrap (GdkCicpParams * object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

Gdk::CicpParams contains the parameters that define a colorstate according to the ITU-T H.273 specification.

See the documentation of individual properties for supported values.

The 'unspecified' value (2) is not treated in any special way, and must be replaced by a different value before creating a color state.

Gdk::CicpParams can be used as a builder object to construct a color state from Cicp data with build_color_state(). The function will throw an exception if the given parameters are not supported.

You can obtain a Gdk::CicpParams object from a color state with Gdk::ColorState::create_cicp_params(). This can be used to create a variant of a color state, by changing just one of the cicp parameters, or just to obtain information about the color state.

Since gtkmm 4.16:

## Constructor & Destructor Documentation

## ◆ CicpParams() [1/2]

Gdk::CicpParams::CicpParams | ( | CicpParams && | src | ) |
| noexcept

## ◆ ~CicpParams()

Gdk::CicpParams::~CicpParams | ( |  | ) |
| override noexcept

## ◆ CicpParams() [2/2]

Gdk::CicpParams::CicpParams | ( |  | ) |
| protected

## Member Function Documentation

## ◆ build_color_state()

Glib::RefPtr< ColorState > Gdk::CicpParams::build_color_state | ( |  | ) | const

Creates a new `Gdk::ColorState` object for the cicp parameters in self.

Note that this may fail if the cicp parameters in self are not supported by GTK. In that case, `nullptr` is returned, and error is set with an error message that can be presented to the user.

Since gtkmm 4.16:

Returns
  A newly allocated `Gdk::ColorState`.

Exceptions

  Gio::Error |

## ◆ create()

static Glib::RefPtr< CicpParams > Gdk::CicpParams::create | ( |  | ) |
| static

Creates a new `Gdk::CicpParams` object.

The initial values of the properties are the values for "undefined" and need to be set before a color state object can be built.

Since gtkmm 4.16:

Returns
  A new `Gdk::CicpParams`.

## ◆ get_color_primaries()

guint Gdk::CicpParams::get_color_primaries | ( |  | ) | const

Returns the value of the color-primaries property of self.

Since gtkmm 4.16:

Returns
  The color-primaries value.

## ◆ get_matrix_coefficients()

guint Gdk::CicpParams::get_matrix_coefficients | ( |  | ) | const

Gets the matrix-coefficients property of self.

Since gtkmm 4.16:

Returns
  The matrix-coefficients value.

## ◆ get_range()

Range Gdk::CicpParams::get_range | ( |  | ) | const

Gets the range property of self.

Since gtkmm 4.16:

Returns
  The range value.

## ◆ get_transfer_function()

guint Gdk::CicpParams::get_transfer_function | ( |  | ) | const

Gets the transfer-function property of self.

Since gtkmm 4.16:

Returns
  The transfer-function value.

## ◆ get_type()

static GType Gdk::CicpParams::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GdkCicpParams * Gdk::CicpParams::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GdkCicpParams * Gdk::CicpParams::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GdkCicpParams * Gdk::CicpParams::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

CicpParams & Gdk::CicpParams::operator= | ( | CicpParams && | src | ) |
| noexcept

## ◆ property_color_primaries() [1/2]

Glib::PropertyProxy< guint > Gdk::CicpParams::property_color_primaries | ( |  | ) |

The color primaries to use.

Supported values:

- 1: BT.709 / sRGB
- 2: unspecified
- 5: PAL
- 6,7: BT.601 / NTSC
- 9: BT.2020
- 10: CIE XYZ

- 12: Display P3

  Since gtkmm 4.16:

Default value: 2

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_color_primaries() [2/2]

Glib::PropertyProxy_ReadOnly< guint > Gdk::CicpParams::property_color_primaries | ( |  | ) | const

The color primaries to use.

Supported values:

- 1: BT.709 / sRGB
- 2: unspecified
- 5: PAL
- 6,7: BT.601 / NTSC
- 9: BT.2020
- 10: CIE XYZ
- 12: Display P3

Since gtkmm 4.16:

Default value: 2

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_matrix_coefficients() [1/2]

Glib::PropertyProxy< guint > Gdk::CicpParams::property_matrix_coefficients | ( |  | ) |

The matrix coefficients (for YUV to RGB conversion).

Supported values:

- 0: RGB

- 2: unspecified

  Since gtkmm 4.16:

Default value: 2

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_matrix_coefficients() [2/2]

Glib::PropertyProxy_ReadOnly< guint > Gdk::CicpParams::property_matrix_coefficients | ( |  | ) | const

The matrix coefficients (for YUV to RGB conversion).

Supported values:

- 0: RGB
- 2: unspecified

Since gtkmm 4.16:

Default value: 2

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_range() [1/2]

Glib::PropertyProxy< Range > Gdk::CicpParams::property_range | ( |  | ) |

Whether the data is using the full range of values.

The range of the data.

Since gtkmm 4.16:

Default value: Gdk::CicpParams::Range::NARROW

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_range() [2/2]

Glib::PropertyProxy_ReadOnly< Range > Gdk::CicpParams::property_range | ( |  | ) | const

Whether the data is using the full range of values.

The range of the data.

Since gtkmm 4.16:

Default value: Gdk::CicpParams::Range::NARROW

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_transfer_function() [1/2]

Glib::PropertyProxy< guint > Gdk::CicpParams::property_transfer_function | ( |  | ) |

The transfer function to use.

Supported values:

- 1,6,14,15: BT.709, BT.601, BT.2020
- 2: unspecified
- 4: gamma 2.2
- 5: gamma 2.8
- 8: linear
- 13: sRGB
- 16: BT.2100 PQ

- 18: BT.2100 HLG

  Since gtkmm 4.16:

Default value: 2

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_transfer_function() [2/2]

Glib::PropertyProxy_ReadOnly< guint > Gdk::CicpParams::property_transfer_function | ( |  | ) | const

The transfer function to use.

Supported values:

- 1,6,14,15: BT.709, BT.601, BT.2020
- 2: unspecified
- 4: gamma 2.2
- 5: gamma 2.8
- 8: linear
- 13: sRGB
- 16: BT.2100 PQ
- 18: BT.2100 HLG

Since gtkmm 4.16:

Default value: 2

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ set_color_primaries()

void Gdk::CicpParams::set_color_primaries | ( | guint | color_primaries | ) |

Sets the color-primaries property of self.

Since gtkmm 4.16:

Parameters

  color_primaries | The new color primaries value.

## ◆ set_matrix_coefficients()

void Gdk::CicpParams::set_matrix_coefficients | ( | guint | matrix_coefficients | ) |

Sets the matrix-coefficients property of self.

Since gtkmm 4.16:

Parameters

  matrix_coefficients | The new matrix-coefficients value.

## ◆ set_range()

void Gdk::CicpParams::set_range | ( | Range | range | ) |

Sets the range property of self.

Since gtkmm 4.16:

Parameters

  range | The range value.

## ◆ set_transfer_function()

void Gdk::CicpParams::set_transfer_function | ( | guint | transfer_function | ) |

Sets the transfer-function property of self.

Since gtkmm 4.16:

Parameters

  transfer_function | The new transfer-function value.

## Friends And Related Symbol Documentation

## ◆ wrap()

Glib::RefPtr< Gdk::CicpParams > wrap | ( | GdkCicpParams * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.